SystemOrganization addCategory: #ConfigurationOfGarage!

Object subclass: #ConfigurationOfGarage
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfGarage'!

!ConfigurationOfGarage class methodsFor: 'development support' stamp: 'GuillermoPolito 4/16/2015 13:56'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfGarage class methodsFor: 'private' stamp: 'GuillermoPolito 4/16/2015 13:56'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfGarage class methodsFor: 'private' stamp: 'GuillermoPolito 4/16/2015 13:56'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfGarage class methodsFor: 'private' stamp: 'GuillermoPolito 4/16/2015 13:56'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfGarage class methodsFor: 'metacello tool support' stamp: 'GuillermoPolito 4/16/2015 13:56'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfGarage class methodsFor: 'loading' stamp: 'GuillermoPolito 4/16/2015 13:56'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfGarage class methodsFor: 'loading' stamp: 'GuillermoPolito 4/16/2015 13:56'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfGarage class methodsFor: 'loading' stamp: 'GuillermoPolito 4/16/2015 13:56'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfGarage class methodsFor: 'accessing' stamp: 'GuillermoPolito 4/16/2015 13:56'!
project

	^self new project! !

!ConfigurationOfGarage class methodsFor: 'development support' stamp: 'GuillermoPolito 4/16/2015 13:56'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfGarage methodsFor: 'versions' stamp: 'GuillermoPolito 4/17/2015 11:09'!
baseline01: spec
    <version: '0.1-baseline'>
    
	spec for: #common do: [
		spec repository: 'http://www.smalltalkhub.com/mc/DBXTalk/Garage/main'.
		
		spec package: 'Garage'.
		
		spec package: 'Garage-OpenDBX' with: [ spec requires: 'OpenDBX'; requires: 'Garage' ].
		spec project: 'OpenDBX'
			with: [ 
				spec className: 'ConfigurationOfOpenDBXDriver'.
				spec loads: #( 'Core' ).
				spec file: 'ConfigurationOfOpenDBXDriver'.
				spec versionString: #bleedingEdge.
				spec repository: 'http://www.smalltalkhub.com/mc/DBXTalk/OpenDBX/main'.
			].

		spec package: 'Garage-Mysql' with: [ spec requires: 'MysqlDriver'; requires: 'Garage' ].
		spec package: 'MysqlDriver'
			with: [ spec repository: 'http://smalltalkhub.com/mc/DBXTalk/MysqlDriver/main/' ].
		
		spec package: 'Garage-Postgres' with: [ spec requires: 'Postgres'; requires: 'Garage' ].
		spec project: 'Postgres'
			with: [ 
				spec className: 'ConfigurationOfPostgresV2'.
				spec file: 'ConfigurationOfPostgresV2'.
				spec versionString: #bleedingEdge.
				spec repository: 'http://smalltalkhub.com/mc/DBXTalk/PostgresV2Driver/main/'.
			].
		
		spec package: 'Garage-Sqlite3' with: [ spec requires: 'Garage' ].

		spec
			group: 'default' with: #('ALL');
			group: 'opendbx' with: #('Garage-OpenDBX');
			group: 'mysql' with: #('Garage-Mysql');
			group: 'postgres' with: #('Garage-Postgres');
			group: 'sqlite3' with: #('Garage-Sqlite3').
	] ! !

!ConfigurationOfGarage methodsFor: 'accessing' stamp: 'GuillermoPolito 4/16/2015 13:56'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfGarage methodsFor: 'symbolic versions' stamp: 'GuillermoPolito 4/16/2015 14:05'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.! !

!ConfigurationOfGarage methodsFor: 'accessing' stamp: 'GuillermoPolito 4/16/2015 13:56'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfGarage methodsFor: 'symbolic versions' stamp: 'GuillermoPolito 4/16/2015 13:56'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !
